var status='setup';
var gamemode='countdown';
var activeColor="#11ff11";
var deactiveColor="#444444";
var moves=0;
var timer;
var fisherBonus;
var resetAfterMoves;
var leftStart=0;
var rightStart=0;
var timeOfLastKeyPress=new Date();
var keyPressLockoutTime=100;


//Called onLoading of the page.
//sets up the correct colors
function setupPage()
{
  //set colors of timers
		document.getElementById("leftTimer").style.backgroundColor=deactiveColor;
		document.getElementById("rightTimer").style.backgroundColor=activeColor;
  //set color valribles to timers;  because sometimes "#010203" is stored as rgb(1,2,3) and comparisons won't work
		activeColor=document.getElementById("rightTimer").style.backgroundColor;
		deactiveColor=document.getElementById("leftTimer").style.backgroundColor;
		
		//make the tenths of seconds hide or be shown depended on whether is starts checked
		toggleHideTenths();
  
}

//Called when game starts
function startGame()
{
  //don't allow game to start if one player has 0 time
		if(adjustTime("left", 0)==0 ||adjustTime("right", 0)==0 ) return;
		
		//change status
  status="playing";
		
		//change text to main box, hide arrow, and setup controls
 	document.getElementById("startbox").innerHTML="End Turn";
  hideArrows();
		document.getElementById('controls').style.visibility="hidden";
		
		//prevent color changes while clock is active
		document.getElementById("colorselector").blur();
  
		//find out what game it is (defual it is countdown)
		if (document.getElementById('countdown').checked)
				gamemode="countdown";
		if(document.getElementById('fisher').checked)
				gamemode='fisher';
		if(document.getElementById('hourglass').checked)
				gamemode='hourglass';
		if (document.getElementById('timepermoves').checked)
				gamemode="timepermoves";
  
		//setup of for fisher game
  if (gamemode=='fisher')
		{
		  fisherBonus=document.getElementById('fisherBonus').value;
				fisherBonus=parseInt(fisherBonus);
				if (typeof(fisherBonus)!="number" || fisherBonus<0 ||isNaN(fisherBonus))
				  fisherBonus=0;
		}
		//setup for time per moves game
		if (gamemode=='timepermoves')
		{
		  resetAfterMoves=document.getElementById('resetAfterMoves').value;
				resetAfterMoves=parseInt(resetAfterMoves);
				if (typeof(resetAfterMoves)!="number" || resetAfterMoves<0 || isNaN(resetAfterMoves))
				  gamemode="countdown"; 
		}
		
		//same the starting times (for time permoves and for reset)
		leftStart=adjustTime("left", 0); 
		rightStart=adjustTime("right", 0);
		moves++;
		
		//start timer
  timer=setInterval('countDown()',100);
		
}

//the main function that remove time from the clock every tenth of a second
//deals with regular countdown and hourglass
function countDown()
{
  //find out who's turn it is an subtract one
		var player=playerTurn();
		playertime = adjustTime(player, -1);
		
		//if he has no time left end the game - reset time, change status, change message
		if (playertime==0)
		{
					clearTimeout(timer);
					status="gameover";
					document.getElementById("startbox").innerHTML="Game Over | Press to Reset";
		}
		
		//if it is an hourglass game increase other player by 1
		if(gamemode=='hourglass')
		{
				var otherPlayer=(player=='left')?"right":"left";  
			 adjustTime(otherPlayer, 1);
		}
}

//A major helping funciton for adding, subtracting, and chaning a players time
// player is a string: the function only looks at the first letter and uses it to access the dom (l1, l2)
//amount can be positive or negative
//mode is add or set;  in add mode it will add the give amount of time to player (it may be negative!)
// in set mode player=amount
//the function returns the amount of the the player has after adjustment in tenths of seconds
function adjustTime(player, amount, mode)
{
		//defaults:
		if(mode==null) mode= 'add';
		if(amount==null) amount=0;
		
		//get first letter of player:
		var playerLetter=player[0];
		
		//find values of timer
		value5=document.getElementById(playerLetter+5).alt;
		newvalue5=parseInt(value5);
		value4=document.getElementById(playerLetter+4).alt;
		newvalue4=parseInt(value4);
		value3=document.getElementById(playerLetter+3).alt;
		newvalue3=parseInt(value3);
		value2=document.getElementById(playerLetter+2).alt;
		newvalue2=parseInt(value2);
		value1=document.getElementById(playerLetter+1).alt;
		newvalue1=parseInt(value1);
		
		//calculate what that means in tenths of seconds
		var playertime=newvalue1*6000+newvalue2*600+newvalue3*100+newvalue4*10+newvalue5;
		
		//add or set amount to current time 
		if(mode=='add')
		{
		  playertime=playertime+amount;
		}else if (mode=='set')
		{
		  playertime=amount;
		}
 
	 if(playertime<0)
		{
				playertime==0;
		}
		
		//now change display of to the clock
		displayvalue5=playertime%10;
		document.getElementById(playerLetter+5).alt=displayvalue5;
		document.getElementById(playerLetter+5).src="images/LED_digit_"+displayvalue5+".png";

		displayvalue4=Math.floor((playertime%100)/10);
		document.getElementById(playerLetter+4).alt=displayvalue4;
		document.getElementById(playerLetter+4).src="images/LED_digit_"+displayvalue4+"_with_dot.png";

		displayvalue3=Math.floor((playertime%600)/100);
		document.getElementById(playerLetter+3).alt=displayvalue3;
		document.getElementById(playerLetter+3).src="images/LED_digit_"+displayvalue3+".png";

		displayvalue2=Math.floor((playertime%6000)/600);
		document.getElementById(playerLetter+2).alt=displayvalue2;
		document.getElementById(playerLetter+2).src="images/LED_digit_"+displayvalue2+".png";

		displayvalue1=Math.floor((playertime%60000)/6000);
		document.getElementById(playerLetter+1).alt=displayvalue1;
		document.getElementById(playerLetter+1).src="images/LED_digit_"+displayvalue1+".png";
		
		//return clocks time in tenths of seconds
		return playertime;
}

//returns who currectly is highlighted
function playerTurn()
{
	if (document.getElementById("leftTimer").style.backgroundColor==activeColor)
	{
	  return "left";
	}else
	{
	  return "right";
	}
}

//main  funciton for switching focus of the timer in setup mode and in playing mode
//in setup mode (to change who goes first) 
//and is playing mode it will count moves and add/adjust time for fisher and time per moves
function togglePlayerColors()
{
  //only works in setup or playing mode
		if(status=='paused' || status=="gameover") return;
  
		//check if there is a fisher bonus
		if(status=="playing" && gamemode=='fisher')
		{
		 var player=playerTurn();
			//fisherbonus is in seconds; adjust time is tenths of seonds - so times by ten
			adjustTime(player, fisherBonus*10);
		}
		
		//check if the time resets
		if(status=="playing" && gamemode=='timepermoves')
		{
		  if (Math.floor(moves/2)==resetAfterMoves)
				{
				   adjustTime("left", leftStart, "set");
							adjustTime("right", rightStart, "set");
							moves=0;
				}
		}
		
		//switch colors
		temp=document.getElementById("leftTimer").style.backgroundColor;
		document.getElementById("leftTimer").style.backgroundColor=document.getElementById("rightTimer").style.backgroundColor;
		document.getElementById("rightTimer").style.backgroundColor=temp;
		
		//increase move counter (for timepermoves)
		if (status=="playing")
		{
		 moves++;
			document.getElementById("moves").innerHTML=moves;
		}

}

//toggle pause on and off,  can be done by pressing 'p' or pressing the pause botton
function togglePause()
{

		if (status=="playing")
		{
				clearTimeout(timer);
				document.getElementById("startbox").innerHTML="--Paused--";
				document.getElementById("pausebox").innerHTML="Unpause (p)";
				status="paused";
		}else if(status=="paused")
		{
    timer=setInterval('countDown()',100);
				document.getElementById("startbox").innerHTML="End Turn";
				document.getElementById("pausebox").innerHTML="Pause Game (p)";
				status="playing";
		}

}

//reset clock can be called at any time!
function restart()
{
		clearTimeout(timer);
		status="setup";
		adjustTime("left", leftStart, "set");
		adjustTime("right", rightStart, "set");
		showArrows();
		document.getElementById("startbox").innerHTML="Start Game (spacebar)";
		document.getElementById("pausebox").innerHTML="Pause Game (p)";
		document.getElementById('controls').style.visibility="visible";
		moves=0;

}

//deals with keyboard input:
// p is always toggle pause (will be cassed in any state but togglepause will do nothing unless it is paused or playing)
//in general spacebar and boxpress do the same thing  except in endgame  to prevent the game ending without players knowing
function keyPress(event)
{
  //esc
		if(event.keyCode==27) 
		{
		  restart();
				return
		}
  
		//p
		if (event.keyCode==80)
		{
				togglePause();
				return;
		}
		
		//any other key
		
		//check to see if key is locked out
		var dNow=new Date();
		var milisecondsSinceLastKeyPress=dNow.getTime() -timeOfLastKeyPress.getTime();
		
		//if too recent lock out
  if (milisecondsSinceLastKeyPress<keyPressLockoutTime)
		  return;
		
		//otherwise set new last keypress time to now
		timeOfLastKeyPress=new Date();
  
		//only spacebar starts game
  if (status=="setup" && event.keyCode==32) 
		{
					startGame();
		}else if(status=="playing")  //any key other than space or esc toggles, but may do other things as well (f5 -reload page, f2 -help,  alt-focus on menu etc)
		{
		  togglePlayerColors(); 
		}
}

//start game / change focus of clock / restart clock to setup again
function boxPressed()
{
	if (status=="setup") 
	{
		startGame();
	}else if (status=="gameover")
	{
		restart();
	}else if(status=="playing")
	{
		togglePlayerColors(); 
	}
}

//to adjust the clock for setup
function click(dirrection, id)
{
		//only works in setupmode
		if (status!="setup") return;
		
		//get the value of the current number
		value=document.getElementById(id).alt;
		newvalue=parseInt(value);
		
		//decrease or incease by one
		if (dirrection=='down')
		  newvalue--;
		else
		  newvalue++;
		
		//if is is under 0; make it 9 (or 5 if it is in the minute column)
		if (newvalue<0) newvalue=(id[1]==3)?5:9;
	 
		//if it is over 9 or 5 (if it is in the minute column) make it zero
		if (newvalue>9 || ((id[1]==3) && newvalue>5)) newvalue=0;

	 //if we set time idendically then change other side also
		if(document.getElementById("sameTimes").checked && (id[0]=='l'|| id[0]=='r'))
		{
		 
				document.getElementById("l"+id[1]).alt=newvalue;
				document.getElementById("l"+id[1]).src=(id[1]==4)?"images/LED_digit_"+newvalue+"_with_dot.png":"images/LED_digit_"+newvalue+".png";
				document.getElementById("r"+id[1]).alt=newvalue;
				document.getElementById("r"+id[1]).src=(id[1]==4)?"images/LED_digit_"+newvalue+"_with_dot.png":"images/LED_digit_"+newvalue+".png";

		}else //otherwise just change this one
		{
				document.getElementById(id).alt=newvalue;
				document.getElementById(id).src=(id[1]==4)?"images/LED_digit_"+newvalue+"_with_dot.png":"images/LED_digit_"+newvalue+".png";
			 
		}
}

//to adjust the  game type options; it hides and shows only one option at a time.
function show(id)
{
 //first hide all
 document.getElementById('countdown').style.display="none";
	document.getElementById('fisher').style.display="none";
	document.getElementById('hourglass').style.display="none";
	document.getElementById('timepermoves').style.display="none";
	
	//uncheck all
	document.getElementById('countdown').checked=false;
	document.getElementById('fisher').checked=false;
	document.getElementById('hourglass').checked=false;
	document.getElementById('timepermoves').checked=false;
	
	//now check one, and display one
	document.getElementById(id).style.display="block";
	document.getElementById(id).checked=true;

}

//to hide or show the smallest digit column - tenth of seonds;  checks the check box every time;
function toggleHideTenths()
{
  //make sure not called by constant spacebaring
		document.getElementById("displayTenths").blur();
		if (document.getElementById("displayTenths").checked)
		{			
			document.getElementById("tenthOfSeconds1").style.display="block";
			document.getElementById("tenthOfSeconds2").style.display="block";
		}else
		{
			document.getElementById("tenthOfSeconds1").style.display="none";
			document.getElementById("tenthOfSeconds2").style.display="none";
		}
}

//change the highlight color (active color) defaul is neon green
function changecolor()
{
	 var sideCurrentlyActive=playerTurn();
		newactiveColor=document.getElementById("colorselector").value;
		
  document.getElementById(sideCurrentlyActive+"Timer").style.backgroundColor=newactiveColor
		activeColor=document.getElementById(sideCurrentlyActive+"Timer").style.backgroundColor;
}

//hide and show arrows above numbers
function hideArrows()
{
  for (i=1; i<21; i++)
		{
		  document.getElementById('arrow'+i).style.visibility='hidden';
		}
}
function showArrows()
{
  for (i=1; i<21; i++)
		{
		  document.getElementById('arrow'+i).style.visibility='visible';
		}
}